package com.knauf.ejb.nm;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

/**
 * Bean implementation class for Enterprise Bean: Buchstabe
 */
public abstract class BuchstabeBean implements javax.ejb.EntityBean {
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate()
		throws javax.ejb.CreateException {
		setId(this.getNextId() );
		return this.getId();
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate()
		throws javax.ejb.CreateException {
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * Get accessor for persistent attribute: id
	 */
	public abstract java.lang.Integer getId();
	/**
	 * Set accessor for persistent attribute: id
	 */
	public abstract void setId(java.lang.Integer newId);
	/**
	 * Get accessor for persistent attribute: buchstabe
	 */
	public abstract java.lang.String getBuchstabe();
	/**
	 * Set accessor for persistent attribute: buchstabe
	 */
	public abstract void setBuchstabe(java.lang.String newBuchstabe);
	
	/**Von auen verwendbare Methode aus dem Home-Interface: Ermitteln der nchsten verfgbaren
	 * Buchstabe-ID.
	 * @return Die neue Buchstabe-ID, 1 grer als die maximal vorhandene ID. Wenn es keine gibt,
	 * wird "1" zurckgeliefert.
	 */
	public Integer getNextId()
	{
		Integer intMaxID = null;
		try
		{
			//Wir brauchen das Remote-Home-Interface, in dem die find-Methode definiert ist
			//wre bei einer ejbSelect-Methode nicht ntig gewesen !
			BuchstabeLocalHome buchstabeHome = (BuchstabeLocalHome) this.getEntityContext().getEJBLocalHome();
			BuchstabeLocal buchstabe = buchstabeHome.findByMaxId();
			//Jetzt endlich die ID holen:
			intMaxID = (Integer) buchstabe.getPrimaryKey();
		}
		catch (javax.ejb.FinderException fex)
		{
			//Finder-Exception tritt beim allerersten Abrufen auf: in diesem Fall gibt es noch
			//kein Wort.
			intMaxID = null;
		}

		if (intMaxID == null)
			intMaxID = new Integer (0);
		//Um 1 erhhen:
		return new Integer (intMaxID.intValue() + 1);
	}
	
	/**Erzeugen eines Buchstabe-Objekts, wobei der Buchstabe angegeben wird. Der Key wird automatisch erzeugt.
	 * @param str_Buchstabe Der Buchstabe. Sollte Unique sein.
	 * @return Den Primary Key, hier die ID.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public Integer ejbCreateByBuchstabe(String str_Buchstabe) throws javax.ejb.CreateException
	{
		this.setId (this.getNextId() );
		this.setBuchstabe(str_Buchstabe);
		return this.getId();
	}

	/**Nach dem Erzeugen eines Buchstaben-Objekts, wobei der Name angegeben wird: nichts besonderes zu tun.
	 * @param str_Buchstabe Der Buchstabe (a-z)
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public void ejbPostCreateByBuchstabe (String str_Buchstabe) throws javax.ejb.CreateException
	{
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
		setId(id);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
	}
	/**
	 * This method was generated for supporting the relationship role named worte.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract java.util.Collection getWorte();
	/**
	 * This method was generated for supporting the relationship role named worte.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setWorte(java.util.Collection aWorte);
	
	/**Hinzufgen eines Worts zu den Worten dieses Buchstabens (die einzige Business-Methode).
	 * @param wort Das zuzufgende Wort.
	 * Wenn es bereits vorkommt, geschieht nichts.
	 */
	public void addWort (WortLocal wort)
	{
		Collection collWorte = this.getWorte();
		//Prfen, ob Wort bereits vorkommt.
		boolean bolVorhanden = false;
		Iterator iteratorWort = collWorte.iterator();
		while (iteratorWort.hasNext() == true && bolVorhanden == false)
		{
			//Ist das aktuelle Wort das bergebene Wort ?
			WortLocal wortAktuell = (WortLocal) iteratorWort.next();
			if (wortAktuell.getWort().equals(wort.getWort() ) == true)
				bolVorhanden = true;
		}

		//Zufgen, wenn es den Buchstaben noch nicht in der Liste gibt.
		if (bolVorhanden == false)
		{
			collWorte.add( wort);
		}
	}

	/**Abrufen der Wortliste.
	 * NUR hierber darf ein Client an die Worte kommen. "getWorte" ist nur fr den Container ?
	 * @return Eine Liste aller Worte.
	 */
	public ArrayList getWortListe()
	{
		ArrayList list = new ArrayList();
		Iterator c = this.getWorte().iterator();
		while (c.hasNext())
		{
			list.add((WortLocal)c.next());
		}
		return list;
	}
}
