package com.knauf.ejb.nm;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

/**
 * Bean implementation class for Enterprise Bean: Wort
 */
public abstract class WortBean implements javax.ejb.EntityBean {
	private javax.ejb.EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate()
		throws javax.ejb.CreateException
	{
		//Die neue ID entspricht der bisher hchsten ID + 1:
		setId(this.getNextId());
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate()
		throws javax.ejb.CreateException {
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws javax.ejb.RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * Get accessor for persistent attribute: id
	 */
	public abstract java.lang.Integer getId();
	/**
	 * Set accessor for persistent attribute: id
	 */
	public abstract void setId(java.lang.Integer newId);
	/**
	 * Get accessor for persistent attribute: wort
	 */
	public abstract java.lang.String getWort();
	/**
	 * Set accessor for persistent attribute: wort
	 */
	public abstract void setWort(java.lang.String newWort);
	
	/**Von auen verwendbare Methode aus dem Home-Interface: Ermitteln der nchsten verfgbaren
	 * Wort-ID.
	 * @return Die neue Wort-ID, 1 grer als die maximal vorhandene ID. Wenn es keine gibt,
	 * wird "1" zurckgeliefert.
	 */
	public Integer getNextId()
	{
		Integer intMaxID = null;
		try
		{
			//Wir brauchen das Remote-Home-Interface, in dem die find-Methode definiert ist
			//wre bei einer ejbSelect-Methode nicht ntig gewesen !
			WortLocalHome wortHome = (WortLocalHome) this.getEntityContext().getEJBLocalHome();
			WortLocal wort = wortHome.findByMaxId();
			//Jetzt endlich die ID holen:
			intMaxID = (Integer) wort.getPrimaryKey();
		}
		catch (javax.ejb.FinderException fex)
		{
			//Finder-Exception tritt beim allerersten Abrufen auf: in diesem Fall gibt es noch
			//kein Wort.
			intMaxID = null;
		}

		if (intMaxID == null)
			intMaxID = new Integer (0);
		//Um 1 erhhen:
		return new Integer (intMaxID.intValue() + 1);
	}
	
	/**Erzeugen eines Wort-Objekts, wobei das Wort angegeben wird. Der Key wird automatisch erzeugt.
	 * @param str_Wort Das Wort. Sollte Unique sein.
	 * @return Den Primary Key, hier die ID.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public Integer ejbCreateByWort(String str_Wort) throws javax.ejb.CreateException
	{
		this.setWort(str_Wort);
		this.setId (this.getNextId());
		return this.getId();
	}

	/**Nach dem Erzeugen eines Wort-Objekts, wobei das Wort selbst angegeben wird: nichts besonderes zu tun.
	 * @param str_Wort Das Wort.
	 * @exception CreateException Fehler beim Erzeugen.
	 */
	public void ejbPostCreateByWort (String str_Wort) throws javax.ejb.CreateException
	{
	}
	/**
	 * ejbCreate
	 */
	public java.lang.Integer ejbCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
		setId(id);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(java.lang.Integer id)
		throws javax.ejb.CreateException {
	}
	/**
	 * This method was generated for supporting the relationship role named buchstaben.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract java.util.Collection getBuchstaben();
	/**
	 * This method was generated for supporting the relationship role named buchstaben.
	 * It will be deleted/edited when the relationship is deleted/edited.
	 */
	public abstract void setBuchstaben(java.util.Collection aBuchstaben);
	
	/**Hinzufgen eines Buchstaben zu den Buchstaben dieses Worts (die einzige Business-Methode).
	 * @param buchstabe Der zuzufgende Buchstabe.
	 * Wenn er bereits vorkommt, geschieht nichts (Wort enthlt einen Buchstabe doppelt).
	 */
	public void addBuchstabe (BuchstabeLocal buchstabe)
	{
	  /*try
	  {*/
		Collection collBuchstaben = this.getBuchstaben();
		//Prfen, ob Buchstabe bereits vorkommt.
		boolean bolVorhanden = false;
		Iterator iteratorBuchstabe = collBuchstaben.iterator();
		while (iteratorBuchstabe.hasNext() == true && bolVorhanden == false)
		{
		  //Ist der aktuelle Buchstabe der bergebene Buchstabe ?
		  BuchstabeLocal buchstabeAktuell = (BuchstabeLocal) iteratorBuchstabe.next();
		  if (buchstabeAktuell.getBuchstabe().equals(buchstabe.getBuchstabe() ) == true)
			bolVorhanden = true;
		}
    
		//Zufgen, wenn es den Buchstaben noch nicht in der Liste gibt.
		if (bolVorhanden == false)
		{
		  collBuchstaben.add( buchstabe);
		}
	  /*}
	  catch (java.rmi.RemoteException rex)
	  {
		throw new javax.ejb.EJBException ("RemoteException beim Zufgen eines Buchstabens: " + rex.getMessage(), rex);
	  }*/
	}
  
	/**Entfernen eines Buchstabens aus den Buchstaben dieses Worts.
	 * @param buchstabe Der zu entfernende Buchstabe. Falls er nicht vorhanden ist,
	 * wird eine EJB-Exception ausgelst.
	 */
	public void removeBuchstabe (BuchstabeLocal buchstabe)
	{
	  /*try
	  {*/
		Collection collBuchstaben = this.getBuchstaben();
		Iterator iteratorBuchstabe = collBuchstaben.iterator();
		//Der so gefundene Buchstabe (wird gesetzt, falls er gefunden wird).
		BuchstabeLocal buchstabeVorhanden = null;
		while (iteratorBuchstabe.hasNext() == true && buchstabeVorhanden == null)
		{
		  //Ist der aktuelle Buchstabe der bergebene Buchstabe ?
		  BuchstabeLocal buchstabeAktuell = (BuchstabeLocal) iteratorBuchstabe.next();
		  if (buchstabeAktuell.getBuchstabe().equals(buchstabe.getBuchstabe() ) == true)
			buchstabeVorhanden = buchstabeAktuell;
		}
    
		//Wenn Buchstabe nicht vorhanden ist, dann EJB-Exception auslsen.
		if (buchstabeVorhanden == null)
		{
		  throw new javax.ejb.EJBException ("Buchstabe '" + buchstabe.getBuchstabe() + "' ist in Buchstaben des Worts nicht enthalten.");
		}
      
		//Entfernen:
		collBuchstaben.remove(buchstabeVorhanden);
	  /*}
	  catch (java.rmi.RemoteException rex)
	  {
		throw new javax.ejb.EJBException ("RemoteException beim Zufgen eines Buchstabens: " + rex.getMessage(), rex);
	  }*/
	}

	/**Abrufen der Buchstabenliste.
	 * NUR hierber darf ein Client an die Buchstaben kommen. "getBuchstaben" ist nur fr den Container ?
	 * @return Eine Liste aller Buchstaben.
	 */
	public ArrayList getBuchstabenListe()
	{
	  ArrayList list = new ArrayList();
	  Iterator c = this.getBuchstaben().iterator();
	  while (c.hasNext())
	  {
		list.add((BuchstabeLocal)c.next());
	  }
	  return list;
	}
}
